## ncbi-vdb 2.8.2-2+dfsg

=== debian/changelog ===
ncbi-vdb (2.8.2-2+dfsg-1build1) bionic; urgency=medium

  * No-change rebuild against libmbedcrypto1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 20 Feb 2018 08:45:54 +0000

ncbi-vdb (2.8.2-2+dfsg-1) unstable; urgency=medium

  * New upstream version
  * cme fix dpkg-control
  * Standards-Version: 4.1.1
  * More adaptations to Debian packaged libmbedx
  * d/rules: Do not parse changelog
  * Try better hardening

 -- Andreas Tille <tille@debian.org>  Thu, 19 Oct 2017 23:40:15 +0200
