=== test/align/Makefile ===
# ===========================================================================
#
#                            PUBLIC DOMAIN NOTICE
#               National Center for Biotechnology Information
#
#  This software/database is a "United States Government Work" under the
#  terms of the United States Copyright Act.  It was written as part of
#  the author's official duties as a United States Government employee and
#  thus cannot be copyrighted.  This software/database is freely available
#  to the public for use. The National Library of Medicine and the U.S.
#  Government have not placed any restriction on its use or reproduction.
#
#  Although all reasonable efforts have been taken to ensure the accuracy
#  and reliability of the software and data, the NLM and the U.S.
#  Government do not and cannot warrant the performance or results that
#  may be obtained by using this software or data. The NLM and the U.S.
#  Government disclaim all warranties, express or implied, including
#  warranties of performance, merchantability or fitness for any particular
#  purpose.
#
#  Please cite the author in any work or product based on this material.
#
# ===========================================================================


default: runtests

TOP ?= $(abspath ../..)
MODULE = test/align

TEST_TOOLS = \
	test-load-index \
	test-estimator \
    
include $(TOP)/build/Makefile.env

$(TEST_TOOLS): makedirs
	@ $(MAKE_CMD) $(TEST_BINDIR)/$@

clean: stdclean

#-------------------------------------------------------------------------------
# test-load-index
#
TEST_INDEX_SRC = \
	indextest

TEST_INDEX_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_INDEX_SRC))

TEST_INDEX_LIB = \
	-skapp \
	-sktst \
	-sncbi-vdb

$(TEST_BINDIR)/test-load-index: $(TEST_INDEX_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_INDEX_LIB)


#-------------------------------------------------------------------------------
# test-estimator
#
TEST_ESTIMATOR_SRC = \
	pileup_estimator

TEST_ESTIMATOR_OBJ = \
	$(addsuffix .$(OBJX),$(TEST_ESTIMATOR_SRC))

TEST_ESTIMATOR_LIB = \
	-skapp \
	-sktst \
	-sncbi-ngs-c++ \
	-sncbi-vdb \
    -L$(NGS_LIBDIR) \
	-sngs-c++

$(TEST_BINDIR)/test-estimator: $(TEST_ESTIMATOR_OBJ)
	$(LP) --exe -o $@ $^ $(TEST_ESTIMATOR_LIB)
